
/* openq :  sample program that opens queues */

#ifdef __USAGE
%C	[options]

Where [options] can be:
   -q  queuename.     Open this queue name.
                      e.g. -q //0/test    Opens queue 'test' on current node.
                           -q test        Opens queue 'test' on global queue
                                          administrator (if it exists).
                           -q //23/data1  Opens queue 'data1' on node 23.
   -p  queue options. See 'queue_open()' in the README file.
                      e.g. -p rcpRW
   -h                 Wait for user to hit ENTER before exiting.
   -s  size.          Number of messages the queue can contain. Default 1000.
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#include "queue.h"

main(argc, argv)
int argc;
char *argv[];
{
int qid1;
nid_t nid; 
int opt;
char queuename[80], queueoptions[80];
int hold = 0;
int queuesize = 1000;
char retstring[40];

    nid = getnid();
    queuename[0] = queueoptions[0] = NULL;

    while ((opt = getopt(argc, argv, "s:q:p:h")) != -1) {
        switch(opt) {
        case 'q':
            strcpy(queuename,optarg);
            break;
        case 'p':
            strcpy(queueoptions,optarg);
            break;
        case 's':
            queuesize = atoi(optarg);
            break;
        case 'h':
            hold = 1;
            break;
        }
    }

/* open a queue */

qid1 = queue_open(queuename, queueoptions, queuesize);
printf("Opening queue: %s for %s, queue size of %d\n",
        queuename, queueoptions, queuesize);
queue_return_code_string(qid1, &retstring);
printf("Return on queue open is %d: %s\n",qid1, retstring);

if ( hold ) {
   printf("Hit ENTER");
   getchar();
   }
}
   
