#ifdef __USAGE
%C	[options]

Where [options] can be:
   -n  node  Query the queue administrator on this node.
             Use -n 0 for the 'global' queue administrator (if it exists)
             Default is the current node.
#endif

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include "queue.h"

main(argc, argv)
int argc;
char *argv[];
{
int id;
int i;
nid_t nid;
pid_t pid;
int opt;
int gotone = 0;    /* set to 1 if we found a queue */
struct {
	char queue_header[QHDR_SIZE];
	struct queue_info info_data;
	} data;
char retstring[40];

    nid = getnid();

    while ((opt = getopt(argc, argv, "n:")) != -1) {
        switch(opt) {
        case 'n':
            nid = atoi(optarg);
            break;
        }
    }


for ( id=0; id >= 0; ++id ) {
   if((id = queue_info(nid, id, &data)) >= 0) {
      gotone = 1;
      printf("Queue # %d:  ",id); 
      printf("   name=%s",   data.info_data.queue_info_name);
      printf("   nmsgs=%d\n",data.info_data.queue_info_nmsgs);
      printf("   Waiting processes are: ");
      for ( i=0; i < 20; i++ ) {
          pid = data.info_data.queue_info_tids[i];
          if ( pid == 0 )
             break; 
          else
             printf("%d  ",pid);
          }
      printf("\n\n");
      }
   else {
      if ( !gotone ) {
        queue_return_code_string(id, &retstring);
        printf("Status: %s\n",retstring);
        }
      }
   }
}

