
/* writeq :  write sample data to a queue */

#ifdef __USAGE
%C	[options]

Where [options] can be:
   -q  queuename.     Open this queue name for writing.
                      e.g. -q //0/test    Opens queue 'test' on current node.
                           -q test        Opens queue 'test' on global queue
                                          administrator (if it exists).
                           -q //23/data1  Opens queue 'data1' on node 23.
   -n  messages.      Number of messages to write to the queue. Default=100.
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#include "queue.h"

struct template {
    char qheader[QHDR_SIZE];
    char data[100];
    } msg;

main(argc, argv)
int argc;
char *argv[];
{
int qid, ret;
int opt;
char queuename[80];
int numentries = 100;
int i;
char retstring[40];

    queuename[0] = NULL;

    while ((opt = getopt(argc, argv, "n:q:")) != -1) {
        switch(opt) {
        case 'q':
            strcpy(queuename,optarg);
            break;
        case 'n':
            numentries = atoi(optarg);
            break;
        }
    }

/* open a queue for writing */

qid = queue_open(queuename, "w", 1000);
printf("Opening queue: %s for writing.\n", queuename);
queue_return_code_string(qid, &retstring);
printf("Return on queue open is %d: %s\n",qid, retstring);

if ( qid < 0 )   /* can't open queue for writing, so abort */
   exit(-1);

for ( i=0; i < numentries; i++ ) {
    sprintf(msg.data,"Data item number %d. Priority=%d",i,i);
    ret = queue_write(qid, &msg, 100, i);
    queue_return_code_string(ret, &retstring);
    printf("Added Entry [%d] return on queue_write=%d:%s\n",
            i,ret,retstring);
    }
}

