
/* readq :  read sample data from a queue */

#ifdef __USAGE
%C	[options]

Where [options] can be:
   -q  queuename.     Open this queue name for reading.
                      e.g. -q //0/test    Opens queue 'test' on current node.
                           -q test        Opens queue 'test' on global queue
                                          administrator (if it exists).
                           -q //23/data1  Opens queue 'data1' on node 23.
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#include "queue.h"

struct template {
    char qheader[QHDR_SIZE];
    char data[100];
    } msg;

main(argc, argv)
int argc;
char *argv[];
{
int qid, ret;
int opt;
char queuename[80];
char retstring[40];

    queuename[0] = NULL;

    while ((opt = getopt(argc, argv, "q:")) != -1) {
        switch(opt) {
        case 'q':
            strcpy(queuename,optarg);
            break;
        }
    }

/* open a queue for reading */

qid = queue_open(queuename, "r", 1000);
printf("Opening queue: %s for reading.\n", queuename);
queue_return_code_string(qid, &retstring);
printf("Return on queue open is %d: %s\n",qid, retstring);

if ( qid < 0 )    /* can't open queue for reading so abort */
   exit(-1);

while(1) {
   printf("Waiting for up to 10 seconds for a message...\n");
   ret = queue_read(qid, 0x0a01, &msg, 100);  /* see queue_read() in README */
   if ( ret < 0 ) {
      queue_return_code_string(ret, &retstring);
      printf("Read failed. Return code=%d: %s\n",ret, retstring);
      }
   else
      printf("Got a message!: MSG=%s\n", msg.data);
   }
}

